mod Mauxb

incl Mtex

incl Mtexrc

incl Maux

rem 
  \para \bf  Part. Dyadic Arithmetic.  \end 

rem 
  \para \bf  Dyadic size.  \end 

fun Dsz 'Tex_f1_n2_sz'
  Dsz(0) = 0
  Dsz S1(x) = Dsz(x)+1
  Dsz S2(x) = Dsz(x)+1

rem 
  \para \bf  Dyadic concatenation.  \end 

fun/2 Dconc 'Tex_f2_n2_conc'
  Dconc(x,0) = x
  Dconc(x,S1(y)) = S1 Dconc(x,y)
  Dconc(x,S2(y)) = S2 Dconc(x,y)

rem 
  \para \bf  Dyadic reversal.  \end 

fun Drev 'Tex_f1_n2_rev'
  Drev(0) = 0
  Drev S1(x) = Dconc(1,Drev(x))
  Drev S2(x) = Dconc(2,Drev(x))

rem 
  \para \bf  Part. Binary Trees.  \end 

rem 
  \para \bf  Binary trees.  \end 

pred Bt 
  Bt(0)
  Bt(x,l,r) <- Bt(l) & Bt(r)

rem 
  \para \bf  Size and depth.  \end 

fun Sz 'Tex_f1_rec_nsr_bt_sz'
  Sz(0) = 0
  Sz(x,l,r) = Sz(l)+Sz(r)+1

fun Dp 'Tex_f1_rec_nsr_bt_dp'
  Dp(0) = 0
  Dp(x,l,r) = Max(Dp(l),Dp(r))+1

rem 
  \para \bf  Dyadic indexing in binary trees.  \end 

fun/2 Dlookup 'Tex_f2_rec_nsr_bt_dyadic_lookup'
  Dlookup((x,l,r),0) = x
  Dlookup((x,l,r),S1(i)) = Dlookup(l,i)
  Dlookup((x,l,r),S2(i)) = Dlookup(r,i)

rem 
  \para \bf  Full binary trees.  \end 

pred Fbt 
  Fbt(t) <-> Bt(t) & Sz(t)+1 = Exp(2,Dp(t))

rem 
  \para \bf  New full binary tree.  \end 

fun New 
  New(0) = 0
  New(n+1) = 0,New(n),New(n)

rem 
  \para \bf  Part. Postorder Traversal.  \end 

rem 
  \para \bf  Tree indexing.  \end 

fun/2 Plookup 'Tex_f2_rec_nsr_bt_postorder_lookup'
  Plookup((x,l,r),i) = Plookup(l,i) <- i < Sz(l)
  Plookup((x,l,r),i) = Plookup(r,i-Sz(l)) <- i >= Sz(l) & i < Sz(l)+Sz(r)
  Plookup((x,l,r),i) = x <- i >= Sz(l) & i = Sz(l)+Sz(r)

rem 
  \para \bf  Tree modification.  \end 

fun/3 Pupdate 'Tex_f3_rec_nsr_bt_postorder_update'
  Pupdate((y,l,r),i,x) = y,Pupdate(l,i,x),r <- i < Sz(l)
  Pupdate((y,l,r),i,x) = y,l,Pupdate(r,i-Sz(l),x) <- 
    i >= Sz(l) & i < Sz(l)+Sz(r)
  Pupdate((y,l,r),i,x) = x,l,r <- i >= Sz(l) & i = Sz(l)+Sz(r)

